# Network setup routine by Ray Haque <ray@oddree.com>
# use IZ2S busybox echo for -ne support
# Should only use busybox to move cursor back up
#  to end of prev line.  
# So it still works ok without busybox installed.
# 
# ANSI colors (darK,Red,Green,Yellow,Blue,Magenta,Cyan,White,Normal)
K="\033[1;30m"
R="\033[1;31m"
G="\033[1;32m"
Y="\033[1;33m"
B="\033[1;34m"
M="\033[1;35m"
C="\033[1;36m"
W="\033[1;37m"
N="\033[0m"

/mnt/ffs/bin/busybox echo -ne "\033[2J\033[1;1H" > /dev/tty0
echo "" > /dev/tty0
echo "-- NETWORK SETUP --" > /dev/tty0
echo "" > /dev/tty0
echo "Join a wireless network? [y/"$B"n"$N"]" > /dev/tty0
/mnt/ffs/bin/busybox echo -ne "\033[1A\033[31C" > /dev/tty0
read -s -n1 enablenet < /dev/tty0
case "$enablenet" in
    'y' | 'Y')
	echo $G"y"$N > /dev/tty0
	echo "" > /dev/tty0
#	prevssid=$(grep 'ssid="' /mnt/ffs/etc/wpa_supplicant.conf | sed -e 's/.*ssid="//' -e 's/"//')
	prevssid=$(grep 'ssid="' /mnt/ffs/etc/wpa_supplicant.conf | sed -e 's/.*ssid="/  /' -e 's/"//')
	echo "Configured Access Point(s):" > /dev/tty0
	echo "" > /dev/tty0
	echo $B"$prevssid"$N > /dev/tty0
	echo "" > /dev/tty0
	echo "Use current Wifi settings? ["$B"y"$N"/n]" > /dev/tty0
	/mnt/ffs/bin/busybox echo -ne "\033[1A\033[33C" > /dev/tty0
	read -s -n1 scanfornetwork < /dev/tty0
	case "$scanfornetwork" in
	    'n' | 'N')
		echo $R"n"$N > /dev/tty0
		echo "" > /dev/tty0
		# Run rkdavis's AP choosing routine.
		/mnt/ffs/bin/setup-wifi.sh
		# ... then return here
		;;
            *)
		echo $G"y"$N > /dev/tty0
		;;
	esac
	# Start the daemon and optain an address.
	echo "" >/dev/tty0
	echo "Starting WPA Supplicant ..." > /dev/tty0
	/mnt/ffs/wpa_supplicant/wpa_supplicant -B -ieth0 -c /mnt/ffs/etc/wpa_supplicant.conf > /dev/tty0 
	echo "" >/dev/tty0
	echo "Obtaining an IP address ..." > /dev/tty0
	udhcpc -n > /dev/tty0
	;;
    *)
	echo $R"n"$N > /dev/tty0
	echo "" > /dev/tty0
	;;
esac


