# AP selection routine by rkdavis with some minor
# additions by Ray Haque.
#
# ANSI colors (darK,Red,Green,Yellow,Blue,Magenta,Cyan,White,Normal)
K="\033[1;30m"
R="\033[1;31m"
G="\033[1;32m"
Y="\033[1;33m"
B="\033[1;34m"
M="\033[1;35m"
C="\033[1;36m"
W="\033[1;37m"
N="\033[0m"

echo "Available AP(s)" > /dev/tty0
#echo "~~~~~~~~~~~~~~~" > /dev/tty0
echo $C > /dev/tty0
/mnt/ffs/bin/iwlist eth0 scan | /mnt/ffs/bin/grep 'ESSID' | sed -e 's/.*ESSID:"\([^"]\+\)".*/  \1/' > /dev/tty0
echo $N > /dev/tty0
echo "Enter the SSID (name) of the AP:" > /dev/tty0
echo $K >/dev/tty0
/mnt/ffs/bin/busybox echo -ne "\033[2C" > /dev/tty0
read apname < /dev/tty0
echo $N > /dev/tty0
echo "Choose encryption method:" > /dev/tty0
echo "  "$B"O"$N") Open (no password)" > /dev/tty0
echo "  W) WEP" >/dev/tty0
echo "  P) WPA/WPA2" > /dev/tty0
read -s -n1 apenc < /dev/tty0

echo "ctrl_interface=/tmp/wpa_ctrl" > /mnt/ffs/etc/wpa_supplicant.conf
case "$apenc" in
        'p' | 'P')
		echo "  "$G"p"$N > /dev/tty0
                echo "" > /dev/tty0
                echo "Enter the WPA Passphrase: " > /dev/tty0
		echo $K > /dev/tty0
		/mnt/ffs/bin/busybox echo -ne "\033[2C" > /dev/tty0
                read appassphrase < /dev/tty0
                /mnt/ffs/bin/wpa_passphrase $apname $appassphrase >> /mnt/ffs/etc/wpa_supplicant.conf
                echo $N > /dev/tty0
        ;;
        'w' | 'W')
		echo "  "$G"w"$N > /dev/tty0
                echo "" > /dev/tty0
                echo "Enter the WEP key: " > /dev/tty0
		echo $K > /dev/tty0
		/mnt/ffs/bin/busybox echo -ne "\033[2C" > /dev/tty0
                read apkey < /dev/tty0
                echo "network={
                        ssid=\"$apname\"
                        key_mgmt=NONE
                        wep_key0=\"$apkey\"
                        }" >> /mnt/ffs/etc/wpa_supplicant.conf
                echo $N > /dev/tty0
        ;;
        *)
		echo "  "$G"o"$N > /dev/tty0
                echo "network={
                        ssid=\"$apname\"
                        key_mgmt=NONE
                        }" >> /mnt/ffs/etc/wpa_supplicant.conf
                echo "" > /dev/tty0
        ;;
esac

# Connect to unsafe access points?
echo "Would you like to connect to unsafe or" > /dev/tty0
echo "unencrypted access points in the case" >/dev/tty0
echo "that your choice is unavailable? [y/"$B"n"$N"]" > /dev/tty0
/mnt/ffs/bin/busybox echo -ne "\033[1A\033[39C" > /dev/tty0
read -s -n1 unsafe < /dev/tty0
case "$unsafe" in
        'y' | 'Y')
		echo $G"y"$N > /dev/tty0
		echo "" > /dev/tty0
                echo "network={
                        ssid=\"ANY\"
                        key_mgmt=NONE
                        }" >> /mnt/ffs/etc/wpa_supplicant.conf
        ;;
	*)
		echo $"n"$N > /dev/tty0
		echo "" > /dev/tty0
	;;
esac
